// the state vary, but the initial state.

int state = 0;
unsigned long previousMillis = 0;
unsigned long blinkMillis = 1000;
int buttonState;
bool buttonPressed = false;
//int P4State;
//int P1State;



// setting up the components with the corresponding pin (constants - dont change)

const int B = 3;
const int B2 = 2;
const int P4 = 6;
const int P3 = 8;
const int P2 = 9;
const int P1 = 10;


void setup() {
  // Initialising to input/output.
  pinMode(B, INPUT);   //setting up B as input

  pinMode(P1, OUTPUT);    //setting up P1 as output
  pinMode(P2, OUTPUT);    //setting up P2 as output
  pinMode(P3, OUTPUT);    //setting up P3 as output
  pinMode(P4, OUTPUT);    //setting up P4 as output

}


void workModeP1() {

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 1200000) {
    state = state + 1;
  }
  //      if (millis() - blinkMillis  1000){
  //    P1State != P1State;
  //    digitalWrite(P1,HIGH);
  digitalWrite(P1, HIGH);
  delay (1000);
  digitalWrite(P1, LOW);
  delay (1000);

}

void breakModeP1() {
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis > 1500000) {
    state = state + 1;
  }
//  if (millis() - blinkMillis > 1000) {
//    P4State != P4State;
//    digitalWrite(P4, HIGH);
//  }
    digitalWrite(P1, HIGH);
    digitalWrite(P4, HIGH);
    delay (1000);
    digitalWrite(P4, LOW);
    delay (1000);
}






void workModeP2() {

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 2700000) {
    state = state + 1;
  }
  digitalWrite(P2, HIGH);
  delay (1000);
  digitalWrite(P2, LOW);
  delay (1000);

}

void breakModeP2() {
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 3000000) {
    state = state + 1;
  }
  digitalWrite(P2, HIGH);
  digitalWrite(P4, HIGH);
  delay (1000);
  digitalWrite(P4, LOW);
  delay (1000);
}






void workModeP3() {

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 4200000) {
    state = state + 1;
  }
  digitalWrite(P3, HIGH);
  delay (1000);
  digitalWrite(P3, LOW);
  delay (1000);

}

void breakModeP3() {
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 4500000) {
    state = state + 1;
  }
  digitalWrite(P2, HIGH);
  digitalWrite(P4, HIGH);
  delay (1000);
  digitalWrite(P4, LOW);
  delay (1000);
}








void workModeP4() {

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 5700000) {
    state = state + 1;
  }
  digitalWrite(P4, HIGH);
  delay (1000);
  digitalWrite(P4, LOW);
  delay (1000);

}

void breakModeP4() {
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis > 6900000) {
    state = state + 1;
  }
  digitalWrite(P1, HIGH);
  delay (1000);
  digitalWrite(P1, LOW);
  delay (1000);
  digitalWrite(P2, HIGH);
  delay (1000);
  digitalWrite(P2, LOW);
  delay (1000);
  digitalWrite(P3, HIGH);
  delay (1000);
  digitalWrite(P3, LOW);
  delay (1000);
  digitalWrite(P4, HIGH);
  delay (1000);
  digitalWrite(P4, LOW);
  delay (1000);
}


void loop() {
  // here we set up the modes that we will be using to define the behaviors of the pins
  buttonState = digitalRead(B);
  if (buttonPressed == false && buttonState == LOW) {
    if (state == 0) {
      state = 1;
    }
    else {
      state = 0;
    }
    buttonPressed = true;
    delay(100); // to avoid bouncing.

  }

  if (buttonState == HIGH) { // when you stop pressing, for it to keep running the previous loop
    buttonPressed = false;
    delay(100); // to avoid bouncing.
  }


  if (state == 1) {
    workModeP1();
  }

  else if (state == 2) {
    breakModeP1();
  }

  else if (state == 3) {
    workModeP2();
  }

  else if (state == 4) {
    breakModeP2();
  }

  else if (state == 5) {
    workModeP3();
  }

  else if (state == 6) {
    breakModeP3();
  }

  else if (state == 7) {
    workModeP4();
  }

  else if (state == 8) {
    breakModeP4();
  }
}
